package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WFReminderMapper;
import com.sa.ibiz.demo.demo.domain.WFReminder;
import com.sa.ibiz.demo.demo.service.WFReminderService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WFReminderSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.WFStepActorService;
import com.sa.ibiz.demo.demo.service.WFUserService;

/**
 * 实体[WFReminder] 服务对象接口实现
 */
@Service
public class WFReminderServiceImpl extends ServiceImplBase<WFReminderMapper, WFReminder> implements WFReminderService{

    @Autowired
    private WFStepActorService wfstepactorService;
    @Autowired
    private WFUserService wfuserService;

    @Resource
    private WFReminderMapper wfreminderMapper;


    @Override
    public boolean create(WFReminder et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(WFReminder et){
        this.beforeUpdate(et);
		this.wfreminderMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(WFReminder et){
		return et.getWfreminderid();  
    }

    @Override
    public boolean getDraft(WFReminder et)  {
    if((!StringUtils.isEmpty(et.getWfstepactorid())) && et.getWfstepactor() == null){
            try {
                et.setWfstepactor(wfstepactorService.getById(et.getWfstepactorid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWfuserid())) && et.getWfuser() == null){
            try {
                et.setWfuser(wfuserService.getById(et.getWfuserid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<WFReminder> listDefault(WFReminderSearchFilter filter) {
		return wfreminderMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WFReminder> searchDefault(WFReminderSearchFilter filter) {
		return wfreminderMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wfreminderMapper.selectRow(sql);
    }

 }